//============================================================================
// Name        : HW_01_03_09.cpp
// Author      : Michael Kitt
// Version     : 1.0
// Copyright   :
// Description : Monthly Schedule for Loan (Monthly payment = 1/20th Loan Amount )
//============================================================================

#include <iostream>
using namespace std;
void display_month_schedule (int month_number, double ending_principal, double payment);
int main ()
{
	using namespace std;

	//declares variables and function
	double loan_amount;
	double interest_rate;
	int duration_in_months = 0;
	double monthly_payment;
	double monthly_principal;
	double monthly_interest;
	double remaining_principal;
	double total_interest_paid = 0;
	double effective_interest_rate = 0;


	cout << "Enter amount of loan:\n";
	cin  >> loan_amount;
	cout << "Enter interest rate of loan (i.e. 5.50 for 5.5%):\n";
	cin  >> interest_rate;

	//Initializes user-based variables
	interest_rate /= 100;
	remaining_principal = loan_amount;
	monthly_payment = loan_amount / 20;

	//Calculates successive months principal & interest payments, and remaining principal
	while (remaining_principal > 0)
	{
		duration_in_months++;
		monthly_interest = (interest_rate / 12) * remaining_principal;
		total_interest_paid += monthly_interest;

		if (monthly_payment <= remaining_principal + monthly_interest)
		{
			monthly_principal = monthly_payment - monthly_interest;
		}
		else
		{
			monthly_principal = remaining_principal;
		}

		monthly_payment = monthly_principal+monthly_interest;
		remaining_principal -= monthly_principal;

		//Sends stats to display
		display_month_schedule(duration_in_months,remaining_principal,monthly_payment);
	}


	effective_interest_rate = 100 * (total_interest_paid / loan_amount) * (12.0 / duration_in_months);

	cout.setf(ios::fixed);
	cout.setf(ios::showpoint);
	cout.precision(2);
	cout << "The total interest paid on this loan is $" << total_interest_paid << ".\n"
		 << "This implies an effective interest rate of " << effective_interest_rate << "%.\n";

    return 0;
}
//Displays monthly payment and ending principal remaining for a given month
void display_month_schedule (int month_number, double ending_principal, double payment)
{
	using namespace std;

	cout.setf(ios::fixed);
	cout.setf(ios::showpoint);
	cout.precision(2);

	cout << "Month #" << month_number << endl
		 << "Monthly Payment: $" << payment << endl
		 << "Ending Balance: $" << ending_principal << endl << endl;

}
